#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/sysinfo.h>
#include <sys/statfs.h>
#include <errno.h>

//#include "omglobal.h"
#include "SimpleIni.h"

//#define DEBUG

#define TRACE printf

#ifdef DEBUG
#define DEG(code) code
#else
#define DEG(code)
#endif

#define SEC_APP "APP"
#define SEC_RUN "RUN"

#define _INIFILE "/omAppSU.ini"
#define _TESTFILE  "/testNF.tmp"

using namespace std;

int main(int argc, char** argv)
{
    char inifilename[] = _INIFILE;
    CSimpleIni inifile;
    int iv = inifile.LoadFile(inifilename);
    if (iv != SI_OK)
    {
        DEG(TRACE("Can not open file: %s!\r\n", inifilename));
        return -1;
    }
//    iv = inifile.GetLongValue(SEC_APP, "NoDog");
//    TRACE("NoDog = %d\r\n", iv);
//
//    string str = inifile.GetValue(SEC_APP, "MSG0");
//    TRACE("MSG0 = %s\r\n", str.c_str());

    DEG(TRACE("\r\nsystem information: \r\n"));
    struct sysinfo systeminfo;
    int err = sysinfo(&systeminfo);

    DEG(TRACE("error code = %d\r\n", err));
    DEG(TRACE("sys.totalram = %ld\r\n", systeminfo.totalram));
    DEG(TRACE("sys.freeram = %ld\r\n", systeminfo.freeram));
    DEG(TRACE("sys.bufferram = %ld\r\n", systeminfo.bufferram));
    DEG(TRACE("sys.totalswap = %ld\r\n", systeminfo.totalswap));
    DEG(TRACE("sys.freeswap = %ld\r\n", systeminfo.freeswap));
    DEG(TRACE("sys.mem_unit = %d\r\n", systeminfo.mem_unit));

    if (0 <= err)
    {
    }


    //statfs
    DEG(TRACE("\r\ndisk information: \r\n"));

    char dir[] = "/";
    struct statfs diskInfo;
    int itestNF = 0;
    int iKey = 0;
    char chKey[10];
    char chValue[128];

testNF:
    if (!remove(_TESTFILE))
        DEG(TRACE("NF clear last\r\n"));

    err = statfs(dir, &diskInfo);
    DEG(TRACE("error code = %d\r\n", err));
    if (0 <= err)
    {
        DEG(TRACE("diskInfo.f_type = %d\r\n", diskInfo.f_type));/* 文件系统类型  */
        DEG(TRACE("diskInfo.f_bsize = %d\r\n", diskInfo.f_bsize));/* 经过优化的传输块大小  */
        DEG(TRACE("diskInfo.f_blocks = %ld\r\n", diskInfo.f_blocks));/* 文件系统数据块总数 */
        DEG(TRACE("diskInfo.f_bfree = %ld\r\n", diskInfo.f_bfree)); /* 可用块数 */
        DEG(TRACE("diskInfo.f_bavail = %ld\r\n", diskInfo.f_bavail)); /* 非超级用户可获取的块数 */
        DEG(TRACE("diskInfo.f_files = %ld\r\n", diskInfo.f_files)); /* 文件结点总数 */
        DEG(TRACE("diskInfo.f_ffree = %ld\r\n", diskInfo.f_ffree)); /* 可用文件结点数 */
        DEG(TRACE("diskInfo.f_fsid = %d\r\n", diskInfo.f_fsid)); /* 文件系统标识 */
        DEG(TRACE("diskInfo.f_namelen = %d\r\n", diskInfo.f_namelen));/* 文件名的最大长度 */
        //TRACE("diskInfo.f_frsize = %d\r\n", diskInfo.f_frsize);
        //TRACE("diskInfo.f_flags = %d\r\n", diskInfo.f_flags);

        unsigned char *buffer = (unsigned char*)malloc(diskInfo.f_bsize);
        //unsigned char buffer[diskInfo.f_bsize];
        for (int i=0; i < diskInfo.f_bsize; ++i)
            buffer[i] = i & 0xFF;

        //int  ixK = diskInfo.f_bavail - 1;//保留2个块
        int  ixK = diskInfo.f_bfree - 1;//保留2个块
        int  ixM = 0;
        int  ixMSize = 1024 * 1024 / diskInfo.f_bsize;

        FILE *f = fopen(_TESTFILE, "a+");

        if (f != NULL)
        {
            DEG(TRACE("NF test start: 0 - %d\r\n", ixK));
            for (int i = 0; i < ixK; i++)
            {
                try
                {
                    if (fwrite(buffer, 1, diskInfo.f_bsize, f) != diskInfo.f_bsize)
                    {
//                        if (wnd)
//                            ::PostMessage(wnd, APP_MSGC, 10000, (i+1)*10+4); // xx4 nf错误于xx
                        DEG(TRACE("NF test err: %d\r\n", i));
                        sprintf(chValue, "NF test err: %d", i);
                        sprintf(chKey, "%04d", iKey++);
                        inifile.SetValue(SEC_RUN, chKey, chValue);

                        break;
                    }
                    if ((i + 1) % ixMSize == 0)
                    {
                        ixM++;
                        //TRACE("NF test: %d MB\r\n", ixM);
                    }
                    if (i == ixK - 1)
                    {
                        DEG(TRACE("NF test all: %d\r\n", ixK));
                    }

                }
                catch(...)
                {
//                    if (wnd)
//                        ::PostMessage(wnd, APP_MSGC, 10000, (i+1)*10+5); // xx5 异常于xx
                    DEG(TRACE("NF test exception: %d\r\n", i));
                    sprintf(chValue, "NF test exception: %d", i);
                    sprintf(chKey, "%04d", iKey++);
                    inifile.SetValue(SEC_RUN, chKey, chValue);
                    break;
                }
                //::Sleep(10); // ?减速
            }
        }

        fclose(f);
        DEG(TRACE("NF test clear\r\n"));
        remove(_TESTFILE);
        DEG(TRACE("NF test end\r\n"));
        free(buffer);
    }
    else
    {
        DEG(TRACE("Get disk information err: %s: %s\n", dir, strerror(errno)));
    }

    itestNF++;
    //if (itestNF <= 5) // 两次
    {
//        if (NLedGetDeviceInfo(NLED_SETTINGS_INFO_ID, &nled))
//        {
//            nled.OffOnBlink = 3; // .5s闪
//            NLedSetDevice(NLED_SETTINGS_INFO_ID, &nled);
//        }
        DEG(TRACE("\r\n\r\nNF Test Times: %d\r\n\r\n", itestNF));
        sprintf(chValue, "NF Test Times: %d", itestNF);
        sprintf(chKey, "%03d", iKey++);
        inifile.SetValue(SEC_RUN, chKey, chValue);
        inifile.SaveFile(inifilename);
        //sleep(10);
        goto testNF;
    }

    return 0;
}




